#pragma once
#include "../include/rational.hpp"

#include <string>
#include <fstream>
#include <map>
#include <functional>

class CSaver {
protected:
    std::string fileName;
    std::map<std::string, CRational> &m_variables;
public:
    CSaver(std::map<std::string, CRational> &variablesMap);
    ~CSaver() = default;

    std::string m_log;
    virtual bool save( const std::string &s ) = 0;
    virtual bool load( const std::string &s ) = 0;
};