#include "../include/rational.hpp"
#include "../include/addition.hpp"

CAddition::CAddition( CPrintable *a, CPrintable *b ) : COperator(a, b) {}
CRational *CAddition::evaluate() {
    std::unique_ptr<CRational> a (m_firstArgument->evaluate());
    std::unique_ptr<CRational> b (m_secondArgument->evaluate());
    return a->add(b.get());
}