#include "../include/rational.hpp"
#include "../include/multiplication.hpp"

CMultiplication::CMultiplication( CPrintable *a, CPrintable *b ) : COperator(a, b) {}
CRational *CMultiplication::evaluate() {
    std::unique_ptr<CRational> a (m_firstArgument->evaluate());
    std::unique_ptr<CRational> b (m_secondArgument->evaluate());
    return a->mul(b.get());
}